Installation Guides {#tutorial_table_of_content_install}
==========================

## Building Chrono

-   [Core Chrono module](@ref tutorial_install_chrono)

Additional Chrono functionality is provided through optional modules. Building one or more of these modules can be enabled during CMake configuration. A brief overview of the functionality provided by each module, additional requirements and dependencies, and specific build instructions are provided in the following subsections:

-   [CASCADE module](@ref module_cascade_installation)

-   [COSIMULATION module](@ref module_cosimulation_installation)

-   [DISTRIBUTED module](@ref module_distributed_installation)

-   [FSI module](@ref module_fsi_installation)

-   [IRRLICHT module](@ref module_irrlicht_installation)

-   [MATLAB module](@ref module_matlab_installation)

-   [MKL module](@ref module_mkl_installation)

-   [MUMPS module](@ref module_mumps_installation)

-   [OPENGL module](@ref module_opengl_installation)

-   [PARALLEL module](@ref module_parallel_installation)

-   [POSTPROCESS module](@ref module_postprocess_installation) 

-   [PYTHON module](@ref module_python_installation)

-   [VEHICLE module](@ref module_vehicle_installation)	


## Building a project that uses Chrono

-   [Linking to Chrono](@ref tutorial_install_project)

## Auxiliary tools

#### The PyChrono Python module

- [PyChrono](@ref pychrono_introduction), brief overview
- @subpage pychrono_installation


#### The Chrono::Solidworks add-in tool

- [Chrono::SolidWorks](@ref introduction_chrono_solidworks), brief overview
- @subpage tutorial_install_chrono_solidworks
  