Tutorials {#tutorial_root}
==========================

-   @subpage tutorial_table_of_content_chrono

    Examples about the core functionalities of the Chrono library.
	
-   @subpage tutorial_table_of_content_chrono_irrlicht

    Examples with 3D interactive view, using Irrlicht.

	
## Optional modules

-   @subpage tutorial_table_of_content_chrono_fea

    Basic information about FEA support in Chrono.

-   @subpage tutorial_table_of_content_chrono_vehicle
 
    Modeling and simulating ground vehicles in Chrono.
	
-   @subpage tutorial_table_of_content_chrono_postprocess

    Examples on producing postprocessing data (e.g. POVray or GNUplot output).

-   @subpage tutorial_table_of_content_chrono_python

    Examples on how to parse Python programs.

-   @subpage tutorial_table_of_content_chrono_matlab

    Examples for Matlab inter-operation.

-   @subpage tutorial_table_of_content_chrono_cosimulation

    Examples for cosimulation with Simulink. 

-   @subpage tutorial_table_of_content_chrono_cascade

    Examples for loading CAD models.
	
-   @subpage tutorial_table_of_content_chrono_parallel

    Examples on using the Parallel module.
	
-   @subpage tutorial_table_of_content_chrono_distributed

    Examples on using the Distributed module.

-   @subpage tutorial_table_of_content_chrono_opengl

    Examples on run-time visualization with the OpenGL module.

-   @subpage tutorial_table_of_content_chrono_fsi

    Examples of fluid-solid interaction using the FSI module.	
	

## Other tools


-   @subpage tutorial_table_of_content_pychrono
 
    Learn how to use [PyChrono](@ref pychrono_introduction)

-   @subpage tutorial_table_of_content_chrono_solidworks

    Learn how to use [Chrono::SolidWorks](@ref introduction_chrono_solidworks)


## Chrono training materials

-   [Tutorial slides](@ref tutorial_slides_300)

    Set of tutorial slides for Chrono release 3.0.0

	
## Documentation guides

-    @subpage tutorial_table_of_content_documentation

     Guidelines on writing technical documentation for Chrono (for developers of new modules/features).

